# -*- coding: utf-8 -*-

from django.conf import settings

from message.models import SystemMessageDeleteInfo

from utils.redis.rkeys import SYSTEM_MESSAGE_DELETED_INFO

import json


r = settings.REDIS_CACHE


# 系统消息相关


def set_system_message_delete_info(user_id):
    """ 设置系统消息删除信息 """
    deleted_messages = SystemMessageDeleteInfo.objects.filter(user_id=user_id, status=True)
    deleted_message_ids = [msg.msg_id for msg in deleted_messages]
    r.set(SYSTEM_MESSAGE_DELETED_INFO % user_id, json.dumps(deleted_message_ids))
    return deleted_message_ids


def get_system_message_delete_info(user_id):
    """ 获取系统消息删除信息 """
    return json.loads(r.get(SYSTEM_MESSAGE_DELETED_INFO % user_id) or '[]') or set_system_message_delete_info(user_id)
